;----------------------------------------------------------------
;	Visdom Demo - Part II: JL and Visdom
;
;	(c) 04-05-1991 by JL, re-version for the Visdom Party in NK !!!!
;	(r) 07-03-2012 by JAC!, NTSC color mapping included
;----------------------------------------------------------------
;

sm1	= $b000		;Not_shifted_JLNews_($b40_bytes)
sm2	= $c000		;Shifted_JLNews_($b40_bytes)
sm3	= $dd00		;128_BPL_Visdom_Picture_($2200_bytes)

txtchr	= $2400		;Normal
txtchr1	= $2000		;Shifted_(overwrites_HOTLINE_logo!)

jlsin	= $5000		;JLNews_sinus
vissinh	= $5100		;Visdom_sinus_high
vissinl	= $5200		;Visdom_sinus_low
jlpic	= $5300		;JLNews_packed_piccy
vispic	= $58a0		;Visdom_piccy

hscrol	= $d404

;-----------------------------------------------------------------
	jsr init_visdom	;"Visdom_Demo_Main_Loop"
	jsr vis_intro	;Final Demo-Version on 08-05-91 by JL

vis_main
;	lda $d20a	;For_raster_time_debugging
;	sta $d01a
;	jmp vis_main

	lda #$ff
	sta rastcol
	sta visdcol
vis_main1
	cmp rastcol
	bne vis_main2
	cmp visdcol
	bne vis_main3
	jmp vis_main1

vis_main2
	jsr rasteff
	jsr rasteff
	jmp vis_main

vis_main3
	jsr vis_up
	jsr vis_down
	jmp vis_main

;-----------------------------------------------------------------
vis_dl
	.byte $f0,$70

vis_dl1	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0,$5f,0,0
	.byte $60
vis_dl2	.byte 0,0,0,0,0,0
vis_dl3	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0
	.byte $5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0,$5e,0,0

vis_dl4	.byte 0,0,0,0,0,0
	.byte $52
	.word vis_scrolline
	.byte $41
	.word vis_dl

;-----------------------------------------------------------------
holdon	.byte 0		;Hold_counter
scnt	.byte 0		;Scroll_counter
sspeed	.byte 0		;Scroll_speed
rastcol	.byte 0		;Raster_color/flag
visdcol	.byte 0		;Raster_color/flag
pmgraf	.byte 0		;PM_graphics
pmposi	.byte 0		;PM_HPOS
pmtemp	.byte 0		;Add_temporary
yflag	.byte 0		;Y_move_enable
xpos	.byte 0		;X_move_position
ypos	.byte 0		;Y_move_position
visoft	.byte 0		;Visdom_$d404_temporay
tcolor	.byte 0,0,0,0	;Scroll_text_colors
scolor	.byte 0		;Star_color
vcolor1	.byte 0		;Vidsom_color_1
vcolor2	.byte 0		;Vidsom_color_2

;----------------------------------------------------------------
vis_nmi
;	sta irqa	;Main_NMI
;	stx irqx
;	sty irqy
	pha
	txa
	pha
	tya
	pha
	bit $d40f
	bpl vis_vbi
	jmp vis_dli

vis_nmi1
;	sta irqa	;First_NMI_without_DLI
;	stx irqx
;	sty irqy
	pha
	txa
	pha
	tya
	pha
	jmp vis_vbi12

vis_nmiend
;	lda irqa
;	ldx irqx
;	ldy irqy
	pla
	tay
	pla
	tax
	pla

	rti

;----------------------------------------------------------------
vis_vbi	set $d402,vis_dl

	lda holdon
	beq vis_vbi0
	dec holdon
	jmp vis_vbi10
vis_vbi0
	lda scnt
	sec
	sbc sspeed
	and #7
	sta scnt
	bcs vis_vbi10
	ldx #0
vis_vbi1
	lda vis_scrolline+1,x
	sta vis_scrolline,x
	inx
	cpx #47
	bne vis_vbi1
vis_vbi2
	ldy #0		;Get_char
	lda (tp),y
	bne vis_vbi3
	set tp,vis_test_restart	;Restart_text
	jmp vis_vbi2
vis_vbi3
	cmp #$ff	;Hold_on
	bne vis_vbi4
	iny
	lda (tp),y
	sta holdon
	jmp vis_vbi8
vis_vbi4
	cmp #$fe	;Speed
	bne vis_vbi5
	iny
	lda (tp),y
	sta sspeed
	jmp vis_vbi8
vis_vbi5
	cmp #$fd	;Rasters
	bne vis_vbi6
	iny
	lda (tp),y
	sta rastcol
	jmp vis_vbi8
vis_vbi6
	cmp #$fc	;Visdom_colors
	bne vis_vbi7
	iny
	lda (tp),y
	sta visdcol
	jmp vis_vbi8
vis_vbi7
	cmp #$fb	;Scroll_flash
	bne vis_vbi9
	iny
	lda (tp),y
	sta pmgraf
	lda #$df
	sta pmposi
vis_vbi8
	add tp,2
	jmp vis_vbi2
vis_vbi9
	sta vis_scrolline+47
	inc tp
	bne *+4
	inc tp+1

vis_vbi10
	ldx #59
vis_vbi11
	lda vis_xtab,x	;Move_stars
	sec
	adc vis_gtab,x
	sta vis_xtab,x
	dex
	dex
	bpl vis_vbi11

vis_vbi12
	jsr play_sound	;For_first_NMI
	lda #0		;prepare_stars_PM
	sta $d009
	lda #$80
	sta $d00e
	lda scolor
	sta $d013
	jmp vis_nmiend

;----------------------------------------------------------------
vis_dlloop
	ldx xpos	;Wobble_and_scroll_effects
	clc		;JLNews
	r .= 0
	.rept 60
	lda vis_llo+r*3	;Carry_is_always_clear_here
	adc vis_stab3,x	;LMS_low_byte
	sta vis_dl1+1+r*3
	lda vis_lhi+r*3	;LMS_hi_byte
	adc vis_stab1,x	;Only_contains_$00_and_$10
	sta vis_dl1+2+r*3
	lda vis_stab2,x	;Soft_scroll_values
	sta vis_stab4+r
	inx
	r .= r+1
	.endr

	ldx xpos	;Visdom
	lda vissinl,x
	eor #3
	sta visoft
	lda vissinh,x
	r .= 0
	.rept 33
	sta vis_dl3+1+r*6	;Set_LMS_low_byte_even
	r .= r+1
	.endr
	eor #$80
	r .= 0
	.rept 33
	sta vis_dl3+4+r*6	;Set_LMS_low_byte_even
	r .= r+1
	.endr

	lda #$00
	sta vis_dl2		;Clear_DL
	sta vis_dl2+1
	sta vis_dl2+2
	sta vis_dl2+3
	sta vis_dl2+4
	sta vis_dl2+5


	lda xpos	;DL_Y_scroll
	asl
	clc
	adc xpos
	tax		;X=DL_Y_scroll*3
	lda yflag	;enabled?
	bne *+3
	tax		;X=0
	lda vissinh,x
	lsr
	sta ypos
	tay
	beq vis_dlloop6

	lda #0
	tax
	clc
vis_dlloop4
	adc #$10
	bpl vis_dlloop5
	lda #$10
	inx
vis_dlloop5
	sta vis_dl2,x
	dey
	bne vis_dlloop4

vis_dlloop6
	lda vis_dl2
	eor #$70
	sta vis_dl4
	lda vis_dl2+1
	eor #$70
	sta vis_dl4+1
	lda vis_dl2+2
	eor #$70
	sta vis_dl4+2
	lda vis_dl2+3
	eor #$70
	sta vis_dl4+3
	lda vis_dl2+4
	eor #$70
	sta vis_dl4+4
	lda vis_dl2+5
	eor #$70
	sta vis_dl4+5
	inc xpos
	rts

;-----------------------------------------------------------------
vis_dli	lda #$30
	sta $d40a
	sta $d01a
	clc
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	adc #2
	sta $d40a
	sta $d01a
	pha
	ldx #0
	stx $d018
vis_dli1
	lda vis_ftab1,x
	ldy vis_stab4,x
	sta $d40a
vis_dli2
	sta $d017	;$d018
	sty hscrol
vis_dli2a
	stx $d01e	;$d017
	inx
	lda vis_ftab1,x
	ldy vis_stab4,x
	sta $d40a
vis_dli2b
	sta $d017
	sty hscrol
	lda vis_xtab,x
	sta $d001
	inx
	cpx #60
	bne vis_dli1

	pla
	ldx #0
	sta $d40a
	sta $d01a
	stx $d001
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	sec
	sbc #2
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a

	lda visoft
	sta $d40a
	sta hscrol
	lda vcolor1
	ldx vcolor2
	sta $d017
	stx $d016
	lda #$ff
	sta $d009
	sta $d00e
	lda #4
	sta $d01b

	lda ypos
	ora #<vis_ftab3	;vis_ftab3_may_begin_at_$80_lo!
	sta vis_dli4+1
	ldx #$6f
vis_dli3
	lda vis_ftab2,x
vis_dli4
	ldy vis_ftab3,x
	sta $d40a
	sta $d01a
	sty $d018

	lda vis_xtab1,x
	sta $d001
	ldy vis_ftab4,x
	sty $d013
	sta vis_xtab1+1,x	;Scroll_in_kernel!!
	dex
	bpl vis_dli3
	lda xpos
	tax
	asl
	tay
	clc
	lda jlsin,y
	adc jlsin,x
	ror
	lsr
	clc
	adc #$40
	sta vis_xtab1	;new_HPOS_for_scroll
	lda #0
	ldx #8
	ldy #$ff
	sta $d40a
	sta $d01a
	sta $d001
	stx $d01b
	sty $d008
	lda tcolor+2
	and #$f0
	tax
	lda scnt
	and #7
	lsr
	sta $d40a
	sta hscrol
	stx $d018
	lda #>txtchr
	bcs vis_dli6
	lda #>txtchr1
vis_dli6
	sta $d409
	lda tcolor
	sta $d40a
	sta $d01a
	lda cnt
	and #63
	tay
	lda ctab,y
	and #$0f
vis_dli6_color
	ora #$00	;Color_see_vis_btab3
	ldx tcolor+1
	ldy pmposi
	sta $d40a
	sta $d012
	stx $d01a
	sty $d000
	lda tcolor+2
	ldx tcolor+3
	sta $d40a
	sta $d01a
	stx $d017
	lda pmgraf
	sta $d40a
	sta $d00d
	sta $d40a
	sta $d40a
	sta $d40a
	sta $d40a
	sta $d40a
	sta $d40a
	lda #0
	sta $d40a
	sta $d008
	sta $d00d
	lda tcolor+2
	sta $d40a
	sta $d01a
	lda tcolor+1
	sta $d40a
	sta $d01a
	lda tcolor
	sta $d40a
	sta $d01a
	lda #0
	sta $d40a
	sta $d01a

	lda holdon
	bne vis_dli8
	lda sspeed
	beq vis_dli8
	lsr
	tay
	bcc vis_dli7
	lda scnt
	and #1
	bne vis_dli7
	iny
vis_dli7
	sty pmtemp
	sec
	lda pmposi
	sbc pmtemp
	sta pmposi
	bcs vis_dli8
	lda #0
	sta pmgraf
vis_dli8

	jsr vis_dlloop	;Do_DL_dffects

	inc cnt
	jmp vis_nmiend
	
;-----------------------------------------------------------------
init_visdom
	sei
	lda #0
	sta $d400
	sta $d01a
	lda $d40b
	bne *-3
	sta $d40e
	lda #$fe
	sta $d301
	set $fffa,vis_nmi1
	lda #$40
	sta $d40e

	lda #$24
	sta $d000
	lda #$ff
	sta $d00d
	lda #0
	sta $d01d
	sta $d012	;PM_border_black
	sta $d008
	ldy #0
init_visdom1
	sta sm1,y	;Clear_sm_begin
	sta sm2,y	;Clear_sm_begin
	sta sm3,y	;Clear_sm_begin
	iny
	bne init_visdom1
	lda #32
	ldy #47
init_visdom2
	sta vis_scrolline,y
	dey
	bpl init_visdom2

	lda vis_dli+1		;Map_bar_color
	jsr map_palette
	sta vis_dli+1
	lda vis_btab3+5		;Map_scroll_flash_color
	and #$f0
	jsr map_palette
	sta vis_dli6_color+1

	set tp,vis_welcome	;Convert_ASCII
	ldy #0
init_visdom_conv
	lda (tp),y
	bmi init_visdom_conv1	;Scroll_code
	cmp #13			;Scroll_end?
	beq init_visdom_conv2
	cmp #$60
	bcc init_visdom_conv1
	and #$5f
	sta (tp),y
init_visdom_conv1
	inc tp
	bne init_visdom_conv
	inc tp+1
	jmp init_visdom_conv

init_visdom_conv2
	set p1,jlpic	;Convert_hires_picture
	lda #24
	sta p2
	sta p3
	lda #>sm1	;Not_shifted
	sta p2+1
	lda #>sm2	;Shifted_pic
	sta p3+1
	ldx #60
init_visdom_conv3
	ldy #0
	clc
	php
init_visdom_conv4
	lda (p1),y
	sta (p2),y
	plp
	ror
	php
	sta (p3),y
	iny
	cpy #24
	bne init_visdom_conv4
	plp
init_visdom_conv5
	lda #0
	sta (p2),y
	sta (p3),y
	iny
	cpy #48
	bne init_visdom_conv5
	add p1,24
	add p2,48
	add p3,48
	dex
	bne init_visdom_conv3

	set p1,vispic	;Copy_Visdom_picture
	set p2,[sm3+24]
	ldx #66		;Lines
init_visdom_conv6
	ldy #127	;Bytes_per_line
	lda #0
init_visdom_conv7
	sta (p2),y
	dey
	cpy #79
	bne init_visdom_conv7
init_visdom_conv8
	lda (p1),y
	sta (p2),y
	dey
	bpl init_visdom_conv8
	add p1,80
	add p2,128
	dex
	bne init_visdom_conv6

	ldx #0
init_visdom_conv9
	lda txtchr,x	;Shift_charset
	and #$7f
	sta txtchr,x
	sec
	rol
	sta txtchr1,x
	lda txtchr+$100,x
	sec
	rol
	sta txtchr1+$100,x
	lda txtchr+$200,x
	sec
	rol
	sta txtchr1+$200,x
	lda txtchr+$300,x
	sec
	rol
	sta txtchr1+$300,x
	inx
	bne init_visdom_conv9

	ldx #0
	set p1,sm1	;JLpic
init_visdom_genadr
	lda p1		;Line_adresses
	sta vis_llo,x
	clc
	adc #48
	sta p1
	lda p1+1
	sta vis_lhi,x
	adc #0
	sta p1+1
	inx
	inx
	inx
	cpx #180	;60_Lines_*3
	bne init_visdom_genadr

	ldx #0
	ldy #>sm3
init_visdom_genadr1
	tya		;Init_Visdom_LMS
	sta vis_dl3+2,x
	sta vis_dl3+5,x
	iny
	inx
	inx
	inx
	inx
	inx
	inx
	cpx #198	;66_Lines_*3
	bne init_visdom_genadr1

	ldx #0
init_visdom_gentab
	lda jlsin,x	;$d404_scroll
	lsr
	and #3
	eor #3
	sta vis_stab2,x
	lda #0		;one_pixel_shift
	bcs init_visdom_gentab1
	lda #$10	;sm1_to_sm2_>offset
init_visdom_gentab1
	sta vis_stab1,x
	lda jlsin,x	;full_bytes
	lsr
	lsr
	lsr
	sta vis_stab3,x
	txa		;Color_tab
	sta x1
	and #16
	beq *+4
	lda #15
	eor x1
	jsr map_palette
	sta ctab,x
	inx
	bne init_visdom_gentab

	ldx #0
init_visdom_gentab2
	lda #0
	sta vis_ftab1,x	;Back
	sta vis_ftab2,x
	sta vis_ftab3,x
	sta vis_ftab4,x

	lda $d20a
	sta vis_xtab,x	;Stars
	lda $d20a
	and #3
	sta vis_gtab,x	;Speed
	inx
	bpl init_visdom_gentab2

	set tp,vis_text	;Text_pointer
	set $fffa,vis_nmi
	lda $d40b
	bne *-3
	lda #$c0
	sta $d40e
	lda $d40b
	bne *-3
	sta cnt
	lda #$3f
	sta $d400
	rts

;-----------------------------------------------------------------
vis_intro
	ldx #15			;Blend_it_all_up!!
vis_intro1
	lda vis_welcome,x	;Welcome_text
	sta vis_scrolline+18,x
	dex
	bpl vis_intro1
	lda #100
	jsr wait

	ldx #0			;Blend_up_scroll_text
vis_intro2
	lda vis_btab3,x
	jsr map_palette
	sta tcolor
	lda vis_btab4,x
	jsr map_palette
	sta tcolor+1
	lda vis_btab5,x
	jsr map_palette
	sta tcolor+2
	lda vis_btab6,x
	jsr map_palette
	sta tcolor+3
	lda #3
	jsr wait
	inx
	cpx #6
	bne vis_intro2

	lda #100
	jsr wait

	lda #2			;Wait_for_Visdom
	sta sspeed		;go!
	lda #1
vis_intro3
	cmp sspeed
	bne vis_intro3
	lda #0			;Stop!
	sta sspeed
	lda #50
	jsr wait

	ldx #0			;Switch_on_JLNews
vis_intro4
	txa
	sta vis_ftab1,x
	lda #2
	jsr wait
	inx
	cpx #64
	bne vis_intro4
	lda #40
	jsr wait

	ldx #$e0		;Switch_on_stars
vis_intro5
	stx scolor
	lda #2
	jsr wait
	inx
	cpx #$f0
	bne vis_intro5

	lda #1			;Reswitch_regs
	jsr wait
	lda #$18
	sta vis_dli2+1
	sta vis_dli2b+1
	lda #$17
	sta vis_dli2a+1

	ldx #63			;Clear_background_again
	lda #0
vis_intro6
	sta vis_ftab1,x
	dex
	bpl vis_intro6
	lda #50
	jsr wait

	lda #15			;Blend_up_first_color_bar
	sta x1
vis_intro7
	ldx #15
vis_intro8
	lda vis_btab0,x
	sec
	sbc x1
	bpl *+4
	lda #0
	sta vis_ftab2+$60,x
	sta vis_ftab4+$60,x
	dex
	bpl vis_intro8
	lda #2
	jsr wait
	dec x1
	bpl vis_intro7
	lda #50
	jsr wait

	lda #$5f		;Push_down_color_bars
	sta x1
vis_intro9
	lda #15
	sta x2
vis_intro10
	ldy x2
	ldx x1
vis_intro11
	lda vis_btab0,y
	sta vis_ftab2,x
	sta vis_ftab4,x
	dex
	iny
	cpy #16
	bne vis_intro11
	lda #2
	jsr wait
	dec x2
	bpl vis_intro10
	lda #25
	jsr wait
	sec
	lda x1
	sbc #$10
	sta x1
	bpl vis_intro9
	lda #120
	jsr wait

	ldx #0			;Color_PM_fill
vis_intro12
	txa
	and #$f0
	jsr map_palette
	sta x1
	lda vis_ftab2,x
	sec
	sbc #4
	bpl *+4
	lda #0
	beq *+4
	ora x1
	sta vis_ftab4,x
	lda #3
	jsr wait
	inx
	bpl vis_intro12
	lda #100
	jsr wait

	ldx #0
vis_intro13
	lda vis_btab1,x		;Switch_on_Visdom_color_1/2
	sta vcolor1
	lda vis_btab2,x
	sta vcolor2
	lda #3
	jsr wait
	inx
	cpx #13
	bne vis_intro13
	lda #25
	jsr wait

vis_intro14
	lda xpos		;Enable_Y_move
	bne vis_intro14
	lda #$ff
	sta yflag
	lda #100
	jsr wait
	lda #1
	sta sspeed
	rts

vis_btab0	.byte 0,2,4,6,8,10,12,14,14,12,10,8,6,4,2,0
vis_btab1	.byte 0,0,2,4,8,10,12,14,12,10,8,6,4
vis_btab2	.byte 2,4,6,8,10,12,14,12,10,8,8,8,8
vis_btab3	.byte $00,$00,$00,$00,$00,$c2
vis_btab4	.byte $00,$00,$00,$c2,$c4,$c6
vis_btab5	.byte $00,$c2,$c4,$c6,$c8,$ca
vis_btab6	.byte $c2,$c4,$c6,$c8,$ca,$cc

;-----------------------------------------------------------------
rasteff	lda #0
	tax
raste1	sta vis_rtab,x
	inx
	bne raste1
raste2	lda ctab,x
	ora rastcol
	sta vis_rtab+$20,x
	inx
	cpx #$20
	bne raste2
	lda #0
	sta x1
raste3	lda x1
	sta x2
	ldx #0
raste4	lda #10
	sta x3
	ldy x2
raste5	lda vis_rtab,y
	sta vis_ftab1,x
	iny
	inx
	dec x3
	bne raste5
	inc x2
	inc x2
	inc x2
	cpx #70
	bne raste4
	lda #1
	jsr wait
	inc x1
	lda x1
	cmp #$40
	bne raste3
	rts

;---------------------------------------------------------------
vis_up	lda #26			;Visdom_blend_to_white
	sta x1
vis_up1	ldx #57
vis_up2	lda vis_ftab3+49,x
	and #$0f
	cmp #$0e
	beq vis_up4
	bcs vis_up3
	inc vis_ftab3+49,x
vis_up3	dex
	bpl vis_up2
	lda #3
	jsr wait
	dec x1
	bne vis_up1
	rts
vis_up4	sta vis_ftab3+49,x
	jmp vis_up3

;---------------------------------------------------------------
vis_down
	lda #15			;Visdom_blend_to_visdcol
	sta x1
vis_down1
	ldx #57
	ldy visdcol
vis_down2
	lda ctab,y
	cmp #$0e
	beq vis_down5
	and #$f0
	sta x2
	lda ctab,y
	and #$0f
	clc
	adc x1
	cmp #16
	bcc vis_down3
	lda #$0e
	bne vis_down4
vis_down3
	ora x2
vis_down4
	sta vis_ftab3+49,x
vis_down5
	iny
	dex
	bpl vis_down2
	lda #3
	jsr wait
	dec x1
	bpl vis_down1
	rts

;-----------------------------------------------------------------
; $ff: Hold, $fe: Speed, $fd: Rasters, $fc: Visdom, $fb: Flash

vis_welcome
	.byte "welcome freaks !!"
vis_text
	.byte $fe,$02
	.byte "this is jl online in 1991! So now prepare for some "
	.byte "* really mindblasting effects *  in my brand new :"
	.byte "                ",$fe,$04
	.byte "--- visdom demo ---             "

	.byte $fe,$01,"yep,but yet another effect is this first real "
	.byte $fb,$f0,"softscroll ever done on xl. "
	.byte "it is soft,because it scrolls with "
	.byte $fb,$e0,"one pixel ... and you know that this is impossible! "
	.byte " (regardless of the little text-",$fb,$fc,"flash!) ",$fe,$02
	.byte "               ",$fe,$03,"                         ",$fe,$01
	.byte "but that is ",$fb,$e0,"not the olny pretty thing here .... "
	.byte "i know you think the black ",$fb,$ff,34,"visdom",34
	.byte " looks quite ugly at the moment ... "
	.byte "but that can be changed!            ",$fe,$02
vis_test_restart
	.byte "                                ",$fc,$58,$fe,$05,$ff,150
	.byte "looks quite nice,eh!             ",$ff,100,$fe,$01
	.byte " - colors are my life,yep - and this demo brings up more "
	.byte "than ",$fb,$f8,"4*128 colors in nearly every scanline! "
	.byte "by the way,my name is ",$fb,$c0,"jl and that is the "
	.byte "short form of (.. look at the top!)",$fe,$03
	.byte "                                            ",$ff,150,$fe,$02
	.byte "oh,i have forgotten to color ",$fb,$c0,"it!        ",$ff,150
	.byte "                                            "
	.byte $fd,$30,32,$ff,150,32,$fd,$40,32,$ff,150,32,$fd,$a0,32,$ff,150
	.byte $fe,$02,"so let",39,"s go for the greetings now:             "
	.byte $fe,$03,"                                       ",$fe,$04
	.byte $fb,$fc,"visdom on amiga               ",$ff,150,$fc,$a0
	.byte "                                dr.",$fb,$f8,"erwin steif"
	.byte "                ",$ff,150,$fd,$e0
	.byte "                      "
	.byte $fb,$e0,"gsp                       ",$ff,150,$fd,$70
	.byte "                          "
	.byte $fb,$f0,"paul and all others ...         ",$ff,150,$fd,$30
	.byte "                                        ",$fe,$01
	.byte "and finally a message to all those who are able to make "
	.byte $fb,$fc,"sounds on xl !!! please contact me under the "
	.byte "following address:               ",$fe,$04
	.byte "peter dell, in der klink 32         ",$ff,250,$fc,$18
	.byte "6601 heusweiler - germany           ",$ff,250,$fd,$10
	.byte "bye for now ... (c) by jl in 91 for ",$fb,$e0,"ppp"
	.byte "                                            "
	.byte $fd,$30,32,$ff,250,32,$fc,$30,32,$ff,250,32,$fd,$a0,32,$ff,250
	.byte 32,$fc,$b0,32,$ff,250,32,$fd,$80,32,$ff,250
	.byte 0
	.byte 13

	.dc [jlsin-*] 0

*	= jlsin
	.incbin "Visdom-I-Part2-JLNews.sin"
*	= jlpic
	.incbin "Visdom-I-Part2-JLNews.pac"

*	= vissinh
	.incbin "Visdom-I-Part2-Visdom.sin"
*	= vispic
	.incbin "Visdom-I-Part2-Visdom.pic"

